<script setup>
import {ref} from 'vue';
import {
  discordLogin,
  discordSendCode,
  genericError,
  keyLogin,
  lostKey,
  mailLogin,
  mailSendCode,
  reloadToken,
  telegramLogin,
  telegramSendCode
} from "@/common/ServerAPI.js";
import router from "@/router/index.js";

const loginMethod = ref(null);
const formatError = ref(false);
const codeError = ref(false);
const codeSent = ref(false);
const loginError = ref(false);
const sentLostKey = ref(false);
const sendLostKeyMins = ref("");
const username = ref("");
const code = ref("");

function getBack() {
  loginMethod.value = null;
  formatError.value = false;
  codeError.value = false;
  codeSent.value = false;
  loginError.value = false;
  sentLostKey.value = false;
  username.value = "";
  code.value = "";
}

const discord = {
  description: "Votre nom d'utilisateur Discord, à ne pas confondre avec le pseudo Discord",
  onerror: "Utilisateur introuvable ou pas vérifié",
  placeholder: "discord",
  sendCode: discordSendCode,
  login: discordLogin
}

const telegram = {
  description: "Votre nom d'utilisateur Telegram (commence par un @)",
  onerror: "Utilisateur introuvable ou pas vérifié",
  placeholder: "@telegram",
  sendCode: telegramSendCode,
  login: telegramLogin
}

const key = {
  name: "Connexion via clé S4S",
  description: "Votre clé S4S (commence par s4skey_***)",
  onerror: "Compte introuvable",
  placeholder: "s4skey_88888888888888888888",
  sendCode: ((key) => {
    formatError.value = false;
    codeError.value = false;
    keyLogin(key, response => {
      if (response === "INVALID") {
        formatError.value = true;
      } else if (response === "FAILURE") {
        codeError.value = true;
      } else if (response.startsWith("TOKEN:")) {
        onTokenReceived(response);
      } else {
        genericError()
      }
    })
  })
}

const lostKeyMethod = {
  name: "",
  description: "Pas de soucis. Donnes-nous l'adresse mail avec laquelle tu t'es inscris",
  onerror: "Compte introuvable !",
  placeholder: "mail@example.com",
  sendCode: ((mail) => {
    formatError.value = false;
    codeError.value = false;
    lostKey(mail, response => {
      if (response === "INVALID") {
        formatError.value = true;
      } else if (response.startsWith("SUCCESS:")) {
        sentLostKey.value = true;
        sendLostKeyMins.value = Math.ceil(parseInt(response.slice("SUCCESS:".length)) / 60000) + " minutes";
      } else if (response === "NOT FOUND") {
        codeError.value = true;
      } else {
        genericError();
      }
    })
  })
}

const mail = {
  name: "Connexion via mail",
  description: "Votre adresse mail",
  onerror: "Une erreur est survenue. Vérifiez votre adresse mail.",
  placeholder: "mail@example.com",
  sendCode: mailSendCode,
  login: mailLogin
}


function sendCode() {
  formatError.value = false;
  codeError.value = false;
  loginMethod.value.sendCode(username.value, response => {
    if (response === "SUCCESS") {
      codeSent.value = true;
    } else if (response === "INVALID") {
      formatError.value = true;
    } else if (response === "NOT FOUND") {
      codeError.value = true;
    } else {
      genericError();
    }
  });
}

function onTokenReceived(response) {
  localStorage.setItem("token", response.slice("TOKEN:".length));
  reloadToken();
  router.replace("/");
}

function login() {
  loginError.value = false;
  loginMethod.value.login(username.value, code.value, response => {
    if (response === "FAILURE") {
      loginError.value = true;
    } else if (response.startsWith("TOKEN:")) {
      onTokenReceived(response);
    } else {
      genericError()
    }
  });
}

</script>
<template>
  <section class="bg-gray-50 dark:bg-gray-900 md:mt-20">
    <div class="flex flex-col items-center justify-center px-6 py-8 mx-auto lg:py-0">
      <div
          class="w-full bg-s4s-redwood-600 rounded-lg shadow dark:border md:mt-0 sm:max-w-md xl:p-0 dark:bg-gray-800 dark:border-gray-700">
        <div class="p-6 space-y-4 md:space-y-6 sm:p-8">
          <h1
              class="text-xl font-bold leading-tight tracking-tight text-gray-900 md:text-2xl dark:text-white">
            {{ loginMethod?.name === lostKeyMethod.name ? "Récupération de la clé" : "Connexion à votre compte S4S" }}
          </h1>
          <div v-if="loginMethod?.name === lostKeyMethod.name">
            Chef! J'ai perdu ma clé!
          </div>
          <div class="flex flex-col" v-if="!loginMethod">
            <button type="button"
                    class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="loginMethod = key">Connexion via Clé S4S <br>(uniquement pour les participants)
            </button>
            <button type="button"
                    class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="loginMethod = discord">Connexion via Discord <br>(uniquement pour le staff)
            </button>
            <button type="button"
                    class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="loginMethod = telegram">Connexion via Telegram <br>(uniquement pour le staff)
            </button>
            <!--            <button type="button"-->
            <!--                    class="text-white bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"-->
            <!--                    @click="loginMethod = mail">Connexion via Mail-->
            <!--            </button>-->
          </div>
          <div class="flex flex-col" v-if="sentLostKey">
            <p class="block mb-2 text-sm font-medium text-red-600 dark:text-white">
              Un mail a bien été envoyé à {{ username }}.<br>
              Temps d'attente moyen: {{ sendLostKeyMins }}
            </p>
          </div>
          <div class="flex flex-col" v-if="loginMethod && !sentLostKey">
            <div>
              <label for="discord" class="block mb-2 text-sm font-medium text-gray-900 dark:text-white"/>
              {{ loginMethod?.description }}
              <input type="text" name="discord" v-model="username" v-bind:placeholder="loginMethod?.placeholder"
                     class="bg-gray-50 border border-gray-300 text-gray-900 sm:text-sm rounded-lg focus:ring-primary-600 focus:border-primary-600 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
                     required="">
              <p class="block mb-2 text-sm font-medium text-red-600 dark:text-white" v-if="formatError">
                La saisie a un format incorrect
              </p>
              <p class="block mb-2 text-sm font-medium text-red-600 dark:text-white" v-if="codeError">
                {{ loginMethod?.onerror }}
              </p>
            </div>
            <button type="button"
                    class="text-white mt-4 bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="sendCode()" v-if="!codeSent && !sentLostKey">
              {{
                loginMethod?.name !== key.name ? (loginMethod?.name === lostKeyMethod.name ? "Récupérer la clé par mail" : "Recevoir un code") : "Se connecter"
              }}
            </button>
            <div v-if="codeSent">
              <label for="discord-code" class="block mb-2 text-sm font-medium text-gray-900 dark:text-white">
                Veuillez entrer le code reçu:</label>
              <input type="text" name="discord-code" v-model="code"
                     class="bg-gray-50 border border-gray-300 text-gray-900 sm:text-sm rounded-lg focus:ring-primary-600 focus:border-primary-600 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
                     required="">
              <p class="block mb-2 text-sm font-medium text-red-600 dark:text-white" v-if="loginError">
                Une erreur est survenue. Avez-vous correctement entré le code ou aurait-il expiré ?
                Si le problème persiste, contactez <a href="mailto:s4s@epfl.ch">s4s@epfl.ch</a>
              </p>
            </div>
            <button type="button"
                    class="text-white mt-4 bg-s4s-purple-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="login()" v-if="codeSent">Se connecter
            </button>
            <button type="button" v-if="loginMethod?.name === key.name"
                    class="text-white mt-4 bg-s4s-purple-600 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="loginMethod = lostKeyMethod">J'ai perdu ma clé S4S
            </button>
            <button type="button"
                    class="text-white mt-4 bg-s4s-redwood-900 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800"
                    @click="getBack()">← Une autre méthode
            </button>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
